<%@ Page Language="c#" EnableViewState="false"%>
<%@ Import Namespace="Mvolo.DirectoryListing" %>
<%@ Import Namespace="System.Collections.Generic" %>
<%@ Import Namespace="System.IO" %>
<script runat="server">

    string nxtOrdrN = "A";
    string nxtOrdrM = "A";
    string nxtOrdrS = "A";

    void Page_Load()
    {
        string sortBy = Request.QueryString["C"];
        string sortOrdr = Request.QueryString["O"];

        Response.ContentType = "text/html;charset=ISO-8859-1";

        //
        // Databind to the directory listing
        //
        DirectoryListingEntryCollection listing = Context.Items[DirectoryListingModule.DirectoryListingContextKey] as DirectoryListingEntryCollection;

        if (listing == null)
        {
            throw new Exception("This page cannot be used without the DirectoryListing module");
        }

        //
        // Handle sorting
        //
        if (!string.IsNullOrEmpty(sortBy))
        {
            if (sortBy.Equals("N"))
            {
                if (sortOrdr == "A")
                {
                    listing.Sort(DirectoryListingEntry.CompareFileNames);
                    nxtOrdrN = "D";
                }
                else listing.Sort(DirectoryListingEntry.CompareFileNamesReverse);
            }
            else if (sortBy.Equals("M"))
            {
                if (sortOrdr == "A")
                {
                    listing.Sort(DirectoryListingEntry.CompareDatesModified);
                    nxtOrdrM = "D";
                }
                else listing.Sort(DirectoryListingEntry.CompareDatesModifiedReverse);
            }
            else if (sortBy.Equals("S"))
            {
                if (sortOrdr == "A")
                {
                    listing.Sort(DirectoryListingEntry.CompareFileSizes);
                    nxtOrdrS = "D";
                }
                else listing.Sort(DirectoryListingEntry.CompareFileSizesReverse);
            }
        }

        DirectoryListing.DataSource = listing;
        DirectoryListing.DataBind();
    }

    string GetParentPath()
    {
        string curr = Context.Request.Path.TrimEnd('/');
        int idx = curr.LastIndexOf('/');
        return curr.Substring(0, idx+1);
    }

    string GetFileSizeString(FileSystemInfo info)
    {
        if (info is FileInfo)
        {
            return string.Format("{0}K", ((int)(((FileInfo)info).Length * 10 / (double)1024) / (double)10));
        }
        else
        {
            return string.Empty;
        }
    }
</script>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
 <head>
  <title>Index of <%= Context.Request.Path %></title>
 </head>
 <body>
<h1>Index of <%= Context.Request.Path %></h1>
  <table>
   <tr><th valign="top"><img src="" alt=""></th><th><a href="?C=N&O=<%= nxtOrdrN %>">Name</a></th><th><a href="?C=M&O=<%= nxtOrdrM %>">Last modified</a></th><th><a href="?C=S&O=<%= nxtOrdrS %>">Size</a></th><th><a href="?C=D&O=A">Description</a></th></tr>
   <tr><th colspan="5"><hr></th></tr>
   <tr><td valign="top"><img src="/kodi/icons/back.gif" alt="[PARENTDIR]"></td><td><a href="<%= GetParentPath() %>">Parent Directory</a></td><td>&nbsp;</td><td align="right">  - </td><td>&nbsp;</td></tr>
      <asp:Repeater id="DirectoryListing" runat="server">
       <ItemTemplate><tr><td valign="top"><img src="/kodi/icons/<%# ((DirectoryListingEntry)Container.DataItem).IsDirectory?"folder.gif":"file.gif" %>" alt="[DIR]" /></td><td><a href="<%# ((DirectoryListingEntry)Container.DataItem).Filename+ (((DirectoryListingEntry)Container.DataItem).IsDirectory?"/":"")  %>"><%# ((DirectoryListingEntry)Container.DataItem).Filename %></a></td><td align="right"><%# ((DirectoryListingEntry)Container.DataItem).FileSystemInfo.LastAccessTime.ToString("yyyy-MM-dd HH:mm") %></td><td align="right"><%# GetFileSizeString(((DirectoryListingEntry)Container.DataItem).FileSystemInfo) %></td><td>&nbsp;</td></tr>
       </ItemTemplate>
   </asp:Repeater>
   <tr><th colspan="5"><hr></th></tr>
</table>
</body></html>